var rxjs_1 = require('rxjs');
var config_1 = require('./config');
function Action(target, propertyKey, descriptor) {
    var oldMethod = descriptor.value;
    var eventEmitter = new rxjs_1.Subject();
    descriptor.value = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i - 0] = arguments[_i];
        }
        var returnValue = oldMethod.apply(this, args);
        var $event = { type: propertyKey, result: returnValue, data: Object.assign.apply(Object, [{}].concat(args)) };
        if (returnValue !== false)
            eventEmitter.next($event);
        return returnValue;
    };
    if (!target[config_1.ACTION_EVENT_LIST_ID]) {
        target[config_1.ACTION_EVENT_LIST_ID] = [];
    }
    target[config_1.ACTION_EVENT_LIST_ID].push(eventEmitter);
    return descriptor;
}
exports.Action = Action;
//# sourceMappingURL=decorator.js.map