import { BehaviorSubject, Observable } from 'Rxjs';
import { StoreActionEvent } from './action-event';
export declare class BaseStore<T> {
    list: BehaviorSubject<T[]>;
    events: Observable<StoreActionEvent>;
    size: Observable<number>;
    constructor();
    add(newItem: T): void;
    remove(itemToRemove: T): void;
    update(itemToUpdate: T, upatedItem: T): void;
    _itemsLength(items: any[]): number;
    _eventEmitterFromActions(): Observable<{}>;
}
